# default | pokemon-rogue-battle
Documentation for pokemon-rogue-battle

# Class default

#### Hierarchy (View Summary)

- PokemonSpeciesForm
  - default

#### Implements

- Localizable

- Defined in src/data/pokemon-species.ts:714

##### Index

### Constructors

constructor

### Properties

_formIndex
_generation
ability1
ability2
abilityHidden
baseExp
baseFriendship
baseStats
baseTotal
canChangeForm
catchRate
forms
genderDiffs
growthRate
height
isStarterSelectable
legendary
malePercent
mythical
name
species
speciesId
subLegendary
type1
type2
weight

### Accessors

formIndex
generation

### Methods

cry
generateCandyColors
getAbility
getAbilityCount
getBaseExp
getBaseStat
getBaseStatTotal
getCompatibleFusionSpeciesFilter
getCryKey
getEvolutionLevels
getExpandedSpeciesName
getFormNameToDisplay
getFormSpriteKey
getFullUnlocksData
getIconAtlasKey
getIconId
getLevelMoves
getName
getPassiveAbility
getPrevolutionLevels
getRegion
getRootSpeciesId
getSimulatedEvolutionChain
getSpeciesForLevel
getSpriteAtlasPath
getSpriteId
getSpriteKey
getTrainerSpeciesForLevel
getVariantDataIndex
getWildSpeciesForLevel
hasVariants
isCatchable
isObtainable
isOfType
isRareRegional
isRegional
isTrainerForbidden
loadAssets
localize
validateStarterMoveset

## Constructors

### constructor

- new default(
  id: Species ,
  generation: number,
  subLegendary: boolean,
  legendary: boolean,
  mythical: boolean,
  species: string,
  type1: PokemonType ,
  type2: null | PokemonType ,
  height: number,
  weight: number,
  ability1: Abilities ,
  ability2: Abilities ,
  abilityHidden: Abilities ,
  baseTotal: number,
  baseHp: number,
  baseAtk: number,
  baseDef: number,
  baseSpatk: number,
  baseSpdef: number,
  baseSpd: number,
  catchRate: number,
  baseFriendship: number,
  baseExp: number,
  growthRate: GrowthRate ,
  malePercent: null | number,
  genderDiffs: boolean,
  canChangeForm?: boolean,
  ...forms: PokemonForm [],
  ): default

  #### Parameters

  - id: Species
  - generation: number
  - subLegendary: boolean
  - legendary: boolean
  - mythical: boolean
  - species: string
  - type1: PokemonType
  - type2: null | PokemonType
  - height: number
  - weight: number
  - ability1: Abilities
  - ability2: Abilities
  - abilityHidden: Abilities
  - baseTotal: number
  - baseHp: number
  - baseAtk: number
  - baseDef: number
  - baseSpatk: number
  - baseSpdef: number
  - baseSpd: number
  - catchRate: number
  - baseFriendship: number
  - baseExp: number
  - growthRate: GrowthRate
  - malePercent: null | number
  - genderDiffs: boolean
  - `Optional` canChangeForm: boolean
  - ...forms: PokemonForm []

  #### Returns default

  Overrides PokemonSpeciesForm.constructor

  - Defined in src/data/pokemon-species.ts:726

## Properties

### `Protected`_formIndex

_formIndex: number

Inherited from PokemonSpeciesForm._formIndex

- Defined in src/data/pokemon-species.ts:172

### `Protected`_generation

_generation: number

Inherited from PokemonSpeciesForm._generation

- Defined in src/data/pokemon-species.ts:173

### `Readonly` ability1

ability1: Abilities

Inherited from PokemonSpeciesForm.ability1

- Defined in src/data/pokemon-species.ts:178

### `Readonly` ability2

ability2: Abilities

Inherited from PokemonSpeciesForm.ability2

- Defined in src/data/pokemon-species.ts:179

### `Readonly` abilityHidden

abilityHidden: Abilities

Inherited from PokemonSpeciesForm.abilityHidden

- Defined in src/data/pokemon-species.ts:180

### `Readonly` baseExp

baseExp: number

Inherited from PokemonSpeciesForm.baseExp

- Defined in src/data/pokemon-species.ts:185

### `Readonly` baseFriendship

baseFriendship: number

Inherited from PokemonSpeciesForm.baseFriendship

- Defined in src/data/pokemon-species.ts:184

### `Readonly` baseStats

baseStats: number[]

Inherited from PokemonSpeciesForm.baseStats

- Defined in src/data/pokemon-species.ts:182

### `Readonly` baseTotal

baseTotal: number

Inherited from PokemonSpeciesForm.baseTotal

- Defined in src/data/pokemon-species.ts:181

### `Readonly` canChangeForm

canChangeForm: boolean

- Defined in src/data/pokemon-species.ts:723

### `Readonly` catchRate

catchRate: number

Inherited from PokemonSpeciesForm.catchRate

- Defined in src/data/pokemon-species.ts:183

### `Readonly` forms

forms: PokemonForm []

- Defined in src/data/pokemon-species.ts:724

### `Readonly` genderDiffs

genderDiffs: boolean

Overrides PokemonSpeciesForm.genderDiffs

- Defined in src/data/pokemon-species.ts:722

### `Readonly` growthRate

growthRate: GrowthRate

- Defined in src/data/pokemon-species.ts:720

### `Readonly` height

height: number

Inherited from PokemonSpeciesForm.height

- Defined in src/data/pokemon-species.ts:176

### `Readonly` isStarterSelectable

isStarterSelectable: boolean

Inherited from PokemonSpeciesForm.isStarterSelectable

- Defined in src/data/pokemon-species.ts:187

### `Readonly` legendary

legendary: boolean

- Defined in src/data/pokemon-species.ts:717

### `Readonly` malePercent

malePercent: null | number

- Defined in src/data/pokemon-species.ts:721

### `Readonly` mythical

mythical: boolean

- Defined in src/data/pokemon-species.ts:718

### name

name: string

- Defined in src/data/pokemon-species.ts:715

### `Readonly` species

species: string

- Defined in src/data/pokemon-species.ts:719

### speciesId

speciesId: Species

Inherited from PokemonSpeciesForm.speciesId

- Defined in src/data/pokemon-species.ts:171

### `Readonly` subLegendary

subLegendary: boolean

- Defined in src/data/pokemon-species.ts:716

### `Readonly` type1

type1: PokemonType

Inherited from PokemonSpeciesForm.type1

- Defined in src/data/pokemon-species.ts:174

### `Readonly` type2

type2: null | PokemonType

Inherited from PokemonSpeciesForm.type2

- Defined in src/data/pokemon-species.ts:175

### `Readonly` weight

weight: number

Inherited from PokemonSpeciesForm.weight

- Defined in src/data/pokemon-species.ts:177

## Accessors

### formIndex

- get formIndex(): number

  #### Returns number

  Inherited from PokemonSpeciesForm.formIndex

  - Defined in src/data/pokemon-species.ts:249
- set formIndex(formIndex: number): void

  #### Parameters

  - formIndex: number

  #### Returns void

  Inherited from PokemonSpeciesForm.formIndex

  - Defined in src/data/pokemon-species.ts:253

### generation

- get generation(): number

  #### Returns number

  Inherited from PokemonSpeciesForm.generation

  - Defined in src/data/pokemon-species.ts:241
- set generation(generation: number): void

  #### Parameters

  - generation: number

  #### Returns void

  Inherited from PokemonSpeciesForm.generation

  - Defined in src/data/pokemon-species.ts:245

## Methods

### cry

- cry(soundConfig?: SoundConfig, ignorePlay?: boolean): AnySound

  #### Parameters

  - `Optional` soundConfig: SoundConfig
  - `Optional` ignorePlay: boolean

  #### Returns AnySound

  Inherited from PokemonSpeciesForm.cry

  - Defined in src/data/pokemon-species.ts:636

### generateCandyColors

- generateCandyColors(): number[][]

  #### Returns number[][]

  Inherited from PokemonSpeciesForm.generateCandyColors

  - Defined in src/data/pokemon-species.ts:649

### getAbility

- getAbility(abilityIndex: number): Abilities

  Method to get the ability of a Pokemon species.

  #### Parameters

  - abilityIndex: number

    Which ability to get (should only be 0-2)

  #### Returns Abilities

  The id of the Ability

  Inherited from PokemonSpeciesForm.getAbility

  - Defined in src/data/pokemon-species.ts:274

### getAbilityCount

- getAbilityCount(): number

  Method to get the total number of abilities a Pokemon species has.

  #### Returns number

  Number of abilities

  Inherited from PokemonSpeciesForm.getAbilityCount

  - Defined in src/data/pokemon-species.ts:265

### getBaseExp

- getBaseExp(): number

  #### Returns number

  Inherited from PokemonSpeciesForm.getBaseExp

  - Defined in src/data/pokemon-species.ts:370

### getBaseStat

- getBaseStat(stat: Stat ): number

  Gets the species' base stat amount for the given stat.

  #### Parameters

  - stat: Stat

    The desired stat.

  #### Returns number

  The species' base stat amount.

  Inherited from PokemonSpeciesForm.getBaseStat

  - Defined in src/data/pokemon-species.ts:366

### getBaseStatTotal

- getBaseStatTotal(): number

  Gets the BST for the species

  #### Returns number

  The species' BST.

  Inherited from PokemonSpeciesForm.getBaseStatTotal

  - Defined in src/data/pokemon-species.ts:357

### getCompatibleFusionSpeciesFilter

- getCompatibleFusionSpeciesFilter(): PokemonSpeciesFilter

  #### Returns PokemonSpeciesFilter

  - Defined in src/data/pokemon-species.ts:1192

### getCryKey

- getCryKey(formIndex?: number): string

  #### Parameters

  - `Optional` formIndex: number

  #### Returns string

  Inherited from PokemonSpeciesForm.getCryKey

  - Defined in src/data/pokemon-species.ts:495

### getEvolutionLevels

- getEvolutionLevels(): EvolutionLevel []

  #### Returns EvolutionLevel []

  - Defined in src/data/pokemon-species.ts:1093

### getExpandedSpeciesName

- getExpandedSpeciesName(): string

  Find the name of species with proper attachments for regionals and separate starter forms (Floette, Ursaluna)

  #### Returns string

  a string with the region name or other form name attached

  - Defined in src/data/pokemon-species.ts:832

### getFormNameToDisplay

- getFormNameToDisplay(formIndex?: number, append?: boolean): string

  Find the form name for species with just one form (regional variants, Floette, Ursaluna)

  #### Parameters

  - formIndex: number = 0

    The form index to check (defaults to 0)

  - append: boolean = false

    Whether to append the species name to the end (defaults to false)

  #### Returns string

  the pokemon-form locale key for the single form name ("Alolan Form", "Eternal Flower" etc)

  - Defined in src/data/pokemon-species.ts:846

### getFormSpriteKey

- getFormSpriteKey(formIndex?: number): string

  #### Parameters

  - `Optional` formIndex: number

  #### Returns string

  Overrides PokemonSpeciesForm.getFormSpriteKey

  - Defined in src/data/pokemon-species.ts:1229

### getFullUnlocksData

- getFullUnlocksData(): bigint

  Generates a bigint corresponding to the maximum unlocks possible for this species, taking into account if the species has a male/female gender, and which variants are implemented.

  #### Returns bigint

  bigint Maximum unlocks, can be compared with DexEntry.caughtAttr.

  - Defined in src/data/pokemon-species.ts:1244

### getIconAtlasKey

- getIconAtlasKey(formIndex?: number, shiny?: boolean, variant?: number): string

  #### Parameters

  - `Optional` formIndex: number
  - `Optional` shiny: boolean
  - `Optional` variant: number

  #### Returns string

  Inherited from PokemonSpeciesForm.getIconAtlasKey

  - Defined in src/data/pokemon-species.ts:432

### getIconId

- getIconId(
  female: boolean,
  formIndex?: number,
  shiny?: boolean,
  variant?: number,
  ): string

  #### Parameters

  - female: boolean
  - `Optional` formIndex: number
  - `Optional` shiny: boolean
  - `Optional` variant: number

  #### Returns string

  Inherited from PokemonSpeciesForm.getIconId

  - Defined in src/data/pokemon-species.ts:439

### getLevelMoves

- getLevelMoves(): LevelMoves

  #### Returns LevelMoves

  Inherited from PokemonSpeciesForm.getLevelMoves

  - Defined in src/data/pokemon-species.ts:314

### getName

- getName(formIndex?: number): string

  #### Parameters

  - `Optional` formIndex: number

  #### Returns string

  - Defined in src/data/pokemon-species.ts:799

### getPassiveAbility

- getPassiveAbility(formIndex?: number): Abilities

  Method to get the passive ability of a Pokemon species

  #### Parameters

  - `Optional` formIndex: number

    The form index to use, defaults to form for this species instance

  #### Returns Abilities

  The id of the ability

  Inherited from PokemonSpeciesForm.getPassiveAbility

  - Defined in src/data/pokemon-species.ts:291

### getPrevolutionLevels

- getPrevolutionLevels(): EvolutionLevel []

  #### Returns EvolutionLevel []

  - Defined in src/data/pokemon-species.ts:1114

### getRegion

- getRegion(): Region

  #### Returns Region

  Inherited from PokemonSpeciesForm.getRegion

  - Defined in src/data/pokemon-species.ts:324

### getRootSpeciesId

- getRootSpeciesId(forStarter?: boolean): Species

  Method to get the root species id of a Pokemon. Magmortar.getRootSpeciesId(true) => Magmar Magmortar.getRootSpeciesId(false) => Magby

  #### Parameters

  - forStarter: boolean = false

    boolean to get the nonbaby form of a starter

  #### Returns Species

  The species

  Inherited from PokemonSpeciesForm.getRootSpeciesId

  - Defined in src/data/pokemon-species.ts:233

### getSimulatedEvolutionChain

- getSimulatedEvolutionChain(
  currentLevel: number,
  forTrainer?: boolean,
  isBoss?: boolean,
  player?: boolean,
  ): EvolutionLevel []

  #### Parameters

  - currentLevel: number
  - forTrainer: boolean = false
  - isBoss: boolean = false
  - player: boolean = false

  #### Returns EvolutionLevel []

  - Defined in src/data/pokemon-species.ts:1140

### getSpeciesForLevel

- getSpeciesForLevel(
  level: number,
  allowEvolving?: boolean,
  forTrainer?: boolean,
  strength?: PartyMemberStrength ,
  currentWave?: number,
  ): Species

  #### Parameters

  - level: number
  - allowEvolving: boolean = false
  - forTrainer: boolean = false
  - strength: PartyMemberStrength = PartyMemberStrength.WEAKER
  - currentWave: number = 0

  #### Returns Species

  - Defined in src/data/pokemon-species.ts:962

### getSpriteAtlasPath

- getSpriteAtlasPath(
  female: boolean,
  formIndex?: number,
  shiny?: boolean,
  variant?: number,
  back?: boolean,
  ): string

  #### Parameters

  - female: boolean
  - `Optional` formIndex: number
  - `Optional` shiny: boolean
  - `Optional` variant: number
  - `Optional` back: boolean

  #### Returns string

  Inherited from PokemonSpeciesForm.getSpriteAtlasPath

  - Defined in src/data/pokemon-species.ts:385

### getSpriteId

- getSpriteId(
  female: boolean,
  formIndex?: number,
  shiny?: boolean,
  variant?: number,
  back?: boolean,
  ): string

  #### Parameters

  - female: boolean
  - `Optional` formIndex: number
  - `Optional` shiny: boolean
  - variant: number = 0
  - `Optional` back: boolean

  #### Returns string

  Inherited from PokemonSpeciesForm.getSpriteId

  - Defined in src/data/pokemon-species.ts:390

### getSpriteKey

- getSpriteKey(
  female: boolean,
  formIndex?: number,
  shiny?: boolean,
  variant?: number,
  back?: boolean,
  ): string

  #### Parameters

  - female: boolean
  - `Optional` formIndex: number
  - `Optional` shiny: boolean
  - `Optional` variant: number
  - `Optional` back: boolean

  #### Returns string

  Inherited from PokemonSpeciesForm.getSpriteKey

  - Defined in src/data/pokemon-species.ts:408

### getTrainerSpeciesForLevel

- getTrainerSpeciesForLevel(
  level: number,
  allowEvolving?: boolean,
  strength: PartyMemberStrength ,
  currentWave?: number,
  ): Species

  #### Parameters

  - level: number
  - allowEvolving: boolean = false
  - strength: PartyMemberStrength
  - currentWave: number = 0

  #### Returns Species

  - Defined in src/data/pokemon-species.ts:918

### getVariantDataIndex

- getVariantDataIndex(formIndex?: number): string | number

  Variant Data key/index is either species id or species id followed by -formkey

  #### Parameters

  - `Optional` formIndex: number

    optional form index for pokemon with different forms

  #### Returns string | number

  species id if no additional forms, index with formkey if a pokemon with a form

  Inherited from PokemonSpeciesForm.getVariantDataIndex

  - Defined in src/data/pokemon-species.ts:419

### getWildSpeciesForLevel

- getWildSpeciesForLevel(
  level: number,
  allowEvolving: boolean,
  isBoss: boolean,
  gameMode: GameMode ,
  ): Species

  #### Parameters

  - level: number
  - allowEvolving: boolean
  - isBoss: boolean
  - gameMode: GameMode

  #### Returns Species

  - Defined in src/data/pokemon-species.ts:909

### hasVariants

- hasVariants(): any

  #### Returns any

  - Defined in src/data/pokemon-species.ts:1218

### isCatchable

- isCatchable(): boolean

  #### Returns boolean

  Inherited from PokemonSpeciesForm.isCatchable

  - Defined in src/data/pokemon-species.ts:332

### isObtainable

- isObtainable(): boolean

  #### Returns boolean

  Overrides PokemonSpeciesForm.isObtainable

  - Defined in src/data/pokemon-species.ts:1214

### isOfType

- isOfType(type: number): boolean

  #### Parameters

  - type: number

  #### Returns boolean

  Inherited from PokemonSpeciesForm.isOfType

  - Defined in src/data/pokemon-species.ts:257

### isRareRegional

- isRareRegional(): boolean

  #### Returns boolean

  Inherited from PokemonSpeciesForm.isRareRegional

  - Defined in src/data/pokemon-species.ts:344

### isRegional

- isRegional(): boolean

  #### Returns boolean

  Inherited from PokemonSpeciesForm.isRegional

  - Defined in src/data/pokemon-species.ts:336

### isTrainerForbidden

- isTrainerForbidden(): boolean

  #### Returns boolean

  Inherited from PokemonSpeciesForm.isTrainerForbidden

  - Defined in src/data/pokemon-species.ts:340

### loadAssets

- loadAssets(
  female: boolean,
  formIndex?: number,
  shiny?: boolean,
  variant?: Variant ,
  startLoad?: boolean,
  back?: boolean,
  ): Promise<void>

  #### Parameters

  - female: boolean
  - `Optional` formIndex: number
  - `Optional` shiny: boolean
  - `Optional` variant: Variant
  - `Optional` startLoad: boolean
  - `Optional` back: boolean

  #### Returns Promise<void>

  Inherited from PokemonSpeciesForm.loadAssets

  - Defined in src/data/pokemon-species.ts:588

### localize

- localize(): void

  #### Returns void

  Implementation of Localizable.localize

  - Defined in src/data/pokemon-species.ts:905

### validateStarterMoveset

- validateStarterMoveset(moveset: StarterMoveset , eggMoves: number): boolean

  #### Parameters

  - moveset: StarterMoveset
  - eggMoves: number

  #### Returns boolean

  Inherited from PokemonSpeciesForm.validateStarterMoveset

  - Defined in src/data/pokemon-species.ts:564